require 'love.sound'
require 'love.audio'
require 'love.filesystem'

require 'play'

local needsound = love.thread.getChannel('needsound')
local sound = love.thread.getChannel('sound')
local settings = love.thread.getChannel('settings')

local sin = math.sin
local c = 2 * math.pi
local function instrument(t, len, freq)
	return .5 * sin(c * t * freq) + .3 * sin(c * t * (freq + 1)) + .3 * sin(c * t * (freq - 1))
end
local function ins2(t, len, freq)
	-- horrible
	return .5 * sin(c * t * freq) + (t < .2 and .5 * sin(c * t * (freq + 1)) or 0) + (t >= .2 and .5 * sin(c * t * (freq - 1)) or 0)
end
local function dampen(v, t, len)
	return v * ((len - t) / len) ^ .5
end

local softnotes = true
local damp = false

while true do
	needsound:demand() -- a waiting barrier, only continue if we need to produce a bit of melody
	local t
	local j = math.random(-1, 1)
	local k = math.random() < .2 and 1 or 0
	if math.random() < .5 then
		t = {
			{0, .3, 69 + j, .5},
			{.4, .3, 69 + j, .5},
			{1, .3, 69 + 2 + j + k, .5},
			{1.4, .2, 69 + 3 + j + k, .5},
			{1.6, .3, 69 + j, .5},
			{2, .0, 69 + 3 + j, 0},
		}
	else
		t = {
			{0, .3, 69 + j, .5},
			{.4, .3, 69 + j, .5},
			{1, .3, 69 + 2 + j + k, .5},
			{1.4, .2, 69 + 1 + j + k, .5},
			{1.6, .3, 69 + 3 + j, .5},
			{2, .0, 69 + 3 + j, 0},
		}
	end
	
	if settings:peek() then
		local s = settings:pop()
		if s.softnotes ~= nil then
			softnotes = s.softnotes
		end
		if s.damp ~= nil then
			damp = s.damp
		end
	end
	
	sound:push(love.audio.newSource(play.create(t, softnotes and instrument, damp and dampen)))
end
