require 'play'

function love.load()
	composer = love.thread.newThread('compose.lua')
	needsound = love.thread.getChannel('needsound')
	sound = love.thread.getChannel('sound')
	settings = love.thread.getChannel('settings')
	composer:start()
	needsound:push(true)
	waiting = true
	currsound = nil
	queue = {}
	softnotes = true
	damp = false
end

function refresh()
	queue = {} -- clear queue to speed up results
	needsound:push(true)
end

function love.update(dt)
	if sound:peek() then
		queue[#queue+1] = sound:pop()
		if #queue < 3 then --try to keep 3 fragments in the queue
			needsound:push(true)
		end
	end
	--if composer:peek('error') then
	--	print(composer:get('error'))
	--end
	if (not currsound or currsound:isStopped()) and #queue > 0 then
		currsound = table.remove(queue, 1)
		currsound:play()
		needsound:push(true)
	end
end

function love.keypressed(key)
	if key == ' ' then
		softnotes = not softnotes
		settings:push {softnotes = softnotes}
		refresh()
	elseif key == 'd' then
		damp = not damp
		settings:push {damp = damp}
		refresh()
	elseif key == 'escape' then
		love.event.push 'quit'
	end
end
